//
//  GameScreen.swift
//  CSkiosk
//
//  Created by Emily Techmeier on 3/5/15.
//  Copyright (c) 2015 Emily Techmeier. All rights reserved.
//




import UIKit

class GameScreen: UIViewController {
    
    @IBOutlet weak var questionLabel: UILabel!
    
    @IBOutlet weak var answerButton1: UIButton!
    @IBOutlet weak var answerButton2: UIButton!
    @IBOutlet weak var answerButton3: UIButton!
    @IBOutlet weak var answerButton4: UIButton!
    
    @IBOutlet weak var dropOpacity: UILabel!
    @IBOutlet weak var explanationView: UIView!
    @IBOutlet weak var correctAnswerLabelStatic: UILabel!
    @IBOutlet weak var correctAnswerLabel: UILabel!
    @IBOutlet weak var correctAnswerExplanationLabel: UILabel!
   
    @IBOutlet weak var nextQuestionButton: UIButton!
    
    @IBOutlet weak var thanksForPlayingLabel: UILabel!
    @IBOutlet weak var backToHomeButton: UIButton!
    
    
    
    var questionid = -1
    var questionCount = 0  //how many have been answered
    var done = false  //false until last question has been asked
    var correctAnswer = -1  //to be assigned real values later
    var nums = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15]
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        dropOpacity.hidden = true
        explanationView.hidden = true
        thanksForPlayingLabel.hidden = true
        backToHomeButton.hidden = true
        
        GetQuestionID()
        
        Display()  //displays first question

    }
    
    func GetQuestionID(){
        
            let arrayKey = Int(arc4random_uniform(UInt32(nums.count)))  //random key from array
            questionid = nums[arrayKey]  //your random number
            nums.removeAtIndex(arrayKey)  //make sure the number isn't repeated
        
    }

    
    func NextQuestion(){
        
        
        if done == false {
            
            GetQuestionID()  //get random question
            
            Display()  //displays next question
            
        }
        else {
            
            dropOpacity.hidden = false
            explanationView.hidden = false
            correctAnswerLabel.hidden = true
            correctAnswerExplanationLabel.hidden = true
            correctAnswerLabelStatic.hidden = true
            nextQuestionButton.hidden = true
            thanksForPlayingLabel.hidden = false
            backToHomeButton.hidden = false
            
        }
    }
    
    func Display(){
      
        switch questionid{
        
            case 1:
                questionLabel.text = "Three of the following are musical notes as well as the name of a programming language. Which is not?"
                answerButton1.setTitle("B", forState: UIControlState.Normal)
                answerButton2.setTitle("C#", forState: UIControlState.Normal)
                answerButton3.setTitle("C++", forState: UIControlState.Normal)
                answerButton4.setTitle("F#", forState: UIControlState.Normal)
                correctAnswer = 3
            case 2:
                questionLabel.text = "Where is St. Norbert College located?"
                answerButton1.setTitle("Los Angeles, CA", forState: UIControlState.Normal)
                answerButton2.setTitle("Minneapolis, MN", forState: UIControlState.Normal)
                answerButton3.setTitle("Boise, ID", forState: UIControlState.Normal)
                answerButton4.setTitle("De Pere, WI", forState: UIControlState.Normal)
                correctAnswer = 4
            case 3:
                questionLabel.text = "Which of these is NOT a programming language?"
                answerButton1.setTitle("WizCode", forState: UIControlState.Normal)
                answerButton2.setTitle("C++", forState: UIControlState.Normal)
                answerButton3.setTitle("Scheme", forState: UIControlState.Normal)
                answerButton4.setTitle("Prolog", forState: UIControlState.Normal)
                correctAnswer = 1
            case 4:
                questionLabel.text = "Which of the following is NOT a Computer Science concentration at St. Norbert?"
                answerButton1.setTitle("CS", forState: UIControlState.Normal)
                answerButton2.setTitle("RGB", forState: UIControlState.Normal)
                answerButton3.setTitle("GDI", forState: UIControlState.Normal)
                answerButton4.setTitle("BIS", forState: UIControlState.Normal)
                correctAnswer = 2
            case 5:
                questionLabel.text = "What is the oldest building on St. Norbert campus?"
                answerButton1.setTitle("Todd Wehr Hall", forState: UIControlState.Normal)
                answerButton2.setTitle("Main Hall", forState: UIControlState.Normal)
                answerButton3.setTitle("Boyle Hall", forState: UIControlState.Normal)
                answerButton4.setTitle("Riverside Apartments", forState: UIControlState.Normal)
                correctAnswer = 2
            case 6:
                questionLabel.text = "Which of the following is NOT a valid data type for programming languages?"
                answerButton1.setTitle("Integer", forState: UIControlState.Normal)
                answerButton2.setTitle("String", forState: UIControlState.Normal)
                answerButton3.setTitle("Boolean", forState: UIControlState.Normal)
                answerButton4.setTitle("Maximum", forState: UIControlState.Normal)
                correctAnswer = 4
            case 7:
                questionLabel.text = "A byte usually describes how many bits?"
                answerButton1.setTitle("8", forState: UIControlState.Normal)
                answerButton2.setTitle("16", forState: UIControlState.Normal)
                answerButton3.setTitle("32", forState: UIControlState.Normal)
                answerButton4.setTitle("64", forState: UIControlState.Normal)
                correctAnswer = 1
            case 8:
                questionLabel.text = "What 24 bit color does 'FFFF00' represent in MS Paint?"
                answerButton1.setTitle("Purple", forState: UIControlState.Normal)
                answerButton2.setTitle("Lime", forState: UIControlState.Normal)
                answerButton3.setTitle("Yellow", forState: UIControlState.Normal)
                answerButton4.setTitle("Orange", forState: UIControlState.Normal)
                correctAnswer = 3
            case 9:
                questionLabel.text = "Which of the following is NOT an operating system?"
                answerButton1.setTitle("DOS", forState: UIControlState.Normal)
                answerButton2.setTitle("UNIX", forState: UIControlState.Normal)
                answerButton3.setTitle("Windows NT", forState: UIControlState.Normal)
                answerButton4.setTitle("Java", forState: UIControlState.Normal)
                correctAnswer = 4
            case 10:
                questionLabel.text = "What brand of motorcycle do Dr. Pankratz and Dr. McVey ride?"
                answerButton1.setTitle("Ducati", forState: UIControlState.Normal)
                answerButton2.setTitle("Honda", forState: UIControlState.Normal)
                answerButton3.setTitle("Kawasaki", forState: UIControlState.Normal)
                answerButton4.setTitle("Harley-Davidson", forState: UIControlState.Normal)
                correctAnswer = 4
            case 11:
                questionLabel.text = "What year was St. Norbert established?"
                answerButton1.setTitle("1898", forState: UIControlState.Normal)
                answerButton2.setTitle("1903", forState: UIControlState.Normal)
                answerButton3.setTitle("1920", forState: UIControlState.Normal)
                answerButton4.setTitle("1943", forState: UIControlState.Normal)
                correctAnswer = 1
            case 12:
                questionLabel.text = "WAV file format is associated with what type of files?"
                answerButton1.setTitle("Video", forState: UIControlState.Normal)
                answerButton2.setTitle("Sound", forState: UIControlState.Normal)
                answerButton3.setTitle("Image", forState: UIControlState.Normal)
                answerButton4.setTitle("Word Document", forState: UIControlState.Normal)
                correctAnswer = 2
            case 13:
                questionLabel.text = "What is the name on the new science building on campus as of 2015?"
                answerButton1.setTitle("John Minahan", forState: UIControlState.Normal)
                answerButton2.setTitle("Michels", forState: UIControlState.Normal)
                answerButton3.setTitle("Gehl-Mulva", forState: UIControlState.Normal)
                answerButton4.setTitle("Sensenbrenner", forState: UIControlState.Normal)
                correctAnswer = 3
            case 14:
                questionLabel.text = "From which school did both Dr. Pankratz and Dr. McVey earn their Masters and Doctorate degrees from?"
                answerButton1.setTitle("Purdue University", forState: UIControlState.Normal)
                answerButton2.setTitle("Carnegie Mellon University", forState: UIControlState.Normal)
                answerButton3.setTitle("St. Norbert College", forState: UIControlState.Normal)
                answerButton4.setTitle("Iowa University", forState: UIControlState.Normal)
                correctAnswer = 1
            case 15:
                questionLabel.text = "What is St. Norbert's mascot?"
                answerButton1.setTitle("Bucky Badger", forState: UIControlState.Normal)
                answerButton2.setTitle("The White Squirrel", forState: UIControlState.Normal)
                answerButton3.setTitle("Fleur de Lys", forState: UIControlState.Normal)
                answerButton4.setTitle("Norby the Knight", forState: UIControlState.Normal)
                correctAnswer = 4
            default:
                break
       
        }
        
    }
   
    
    func ShowExplanation(){
        
        dropOpacity.hidden = false
        explanationView.hidden = false
        
        switch correctAnswer {
            
        case 1:
            correctAnswerLabel.text = answerButton1.currentTitle
        case 2:
            correctAnswerLabel.text = answerButton2.currentTitle
        case 3:
            correctAnswerLabel.text = answerButton3.currentTitle
        case 4:
            correctAnswerLabel.text = answerButton4.currentTitle
        default:
            break
            
        }
        
        switch questionid {
        case 1:
            correctAnswerExplanationLabel.text = "B, C#, and F# are all musical notes as well as programming languages.  However, C++ is just a programming language, and is actually the first one you learn when starting your Computer Science education."
        case 2:
            correctAnswerExplanationLabel.text = "St. Norbert College is located in De Pere, WI, a city of about 23,000 people just south of Green Bay, WI."
        case 3:
            correctAnswerExplanationLabel.text = "C++, Prolog, and Scheme are all languages you might work with while studying Computer Science at St. Norbert College, but WizCode is not a language at all."
        case 4:
            correctAnswerExplanationLabel.text = "CS stands for Computer Science, GDI stands for Graphic Design & Implementation Systems, and BIS stands for Business Information Systems.  RGB is a color system in which the amount of Red (R), Green (G), and Blue (B) are specified to make a certain color when mixed together."
        case 5:
            correctAnswerExplanationLabel.text = "Main Hall was completed in 1902 and was the first campus building.  For many years, the entire college was based inside its walls - classrooms, dorms, cafeteria, gymnasium, etc."
        case 6:
            correctAnswerExplanationLabel.text = "An integer is a whole number, a string is multiple characters, and a boolean is either true or false."
        case 7:
            correctAnswerExplanationLabel.text = "There are 8 bits in a byte.  A byte is a unit of data with binary digits, and is the unit most computers use to represent a character such as a letter, number, or typographic symbol."
        case 8:
            correctAnswerExplanationLabel.text = "FFFF00 is used to represent the color Yellow.  This is another way of representing the RGB system, but here the first two values are the Red value, the second two are the Green, and the last two are the Blue.  This color would be 100% Red, 100% Green, and 0% Blue, which is Yellow."
        case 9:
            correctAnswerExplanationLabel.text = "Java is not an operating system, but it is a programming language.  Java is most popularly used for client-server web applications."
        case 10:
            correctAnswerExplanationLabel.text = "Dr. Pankratz and Dr. McVey ride Harley-Davidson motorcycles.  And they both sport Harley t-shirts most days of the week!"
        case 11:
            correctAnswerExplanationLabel.text = "St. Norbert College was established in 1898 when Abbot Bernard Pennings, a Dutch immigrant Norbertine priest, founded the college to train young men for the priesthood."
        case 12:
            correctAnswerExplanationLabel.text = ".WAV is one format in which sound files are saved.  It is the main format used on Windows systems for storing uncompressed, lossless audio."
        case 13:
            correctAnswerExplanationLabel.text = "The John Minihan Science Hall underwent major renovation in the years 2012-2015, and so much work was done that it was renamed to the Gehl-Mulva Science Center.  The new building opens Fall 2015 and houses the Medical College of Wisconsin."
        case 14:
            correctAnswerExplanationLabel.text = "Dr. Pankratz and Dr. McVey both earned their Masters and Doctorate degrees at Purdue University in Indiana.  Go Boilermakers!"
        case 15:
            correctAnswerExplanationLabel.text = "Norby the Knight is St. Norbert's mascot.  Technically, members of the college community are Green Knights, but Norby is the Knight that can be seen at sporting events and other fun things the college puts on."
        default:
            break
        }
        
    }
    
    @IBAction func answerAction1(sender: UIButton) {
        
        
        ShowExplanation()
    }

    @IBAction func answerAction2(sender: UIButton) {
        
        
        ShowExplanation()
        
    }

    @IBAction func answerAction3(sender: UIButton) {
        
        ShowExplanation()
        
    }
    
    @IBAction func answerAction4(sender: UIButton) {
        
        ShowExplanation()
        
    }

    @IBAction func nextQuestionAction(sender: UIButton) {
        
        dropOpacity.hidden = true
        explanationView.hidden = true
        
        if questionCount >= 6 {
            
            done = true
            
        }
        
        questionCount += 1
        NextQuestion()
        
    }
   
    
}
